SetCollectorUpDownStateEvent = {};
SetCollectorUpDownStateEvent_mt = Class(SetCollectorUpDownStateEvent, Event);

InitEventClass(SetCollectorUpDownStateEvent, "SetCollectorUpDownStateEvent");

function SetCollectorUpDownStateEvent:emptyNew()
    local self = Event:new(SetCollectorUpDownStateEvent_mt);
    self.className = "SetCollectorUpDownStateEvent";
    return self;
end;

function SetCollectorUpDownStateEvent:new(object, idx, up, down)
    local self = SetCollectorUpDownStateEvent:emptyNew()
    self.object = object;
	self.idx = idx;
	self.up = up;
	self.down = down;
    return self;
end;

function SetCollectorUpDownStateEvent:readStream(streamId, connection)
    local id = streamReadInt32(streamId);
	self.object = networkGetObject(id);
	self.idx = streamReadUInt8(streamId);
	self.up = streamReadBool(streamId);
	self.down = streamReadBool(streamId);
    self:run(connection);
end;

function SetCollectorUpDownStateEvent:writeStream(streamId, connection)
    streamWriteInt32(streamId, networkGetObjectId(self.object));
	streamWriteUInt8(streamId, self.idx);
	streamWriteBool(streamId, self.up);
	streamWriteBool(streamId, self.down);
end;

function SetCollectorUpDownStateEvent:run(connection)
	self.object:setCollectorUpDownState(self.idx, self.up, self.down, true);
	if not connection:getIsServer() then
		g_server:broadcastEvent(SetCollectorUpDownStateEvent:new(self.object, self.idx, self.up, self.down), nil, connection, self.object);
	end;
end;

function SetCollectorUpDownStateEvent.sendEvent(vehicle, idx, up, down, noEventSend)
	if noEventSend == nil or noEventSend == false then
		if g_server ~= nil then
			g_server:broadcastEvent(SetCollectorUpDownStateEvent:new(vehicle, idx, up, down), nil, nil, vehicle);
		else
			g_client:getServerConnection():sendEvent(SetCollectorUpDownStateEvent:new(vehicle, idx, up, down));
		end;
	end;
end;


